<app-loading *ngIf="isLoading"></app-loading>
<nz-card class="user-permission-card">
  <div nz-row class="form-row">
    <div nz-col nzSm='24' nzLg="12">
      <div class="action-top_header">
        <div class="search-container search-left" [formGroup]="searchFormUserName">
          <input
            nz-input
            placeholder="{{ 'common.label.search' | translate }}"
            (keyup.enter)="searchUser(true)"
            class="input"
            formControlName="username"
          />
          <mb-button class="bt-center" mbButtonType="NO_BORDER" mbButtonSize="VERY_LARGE" (click)="searchUser(true)" mbButtonAvailableStyle="SEARCH"
                     mbPrefixIcon="search" nzTooltipTitle="{{'common.label.search' | translate}}" nzTooltipPlacement="bottom" nz-tooltip></mb-button>
        </div>
      </div>

      <!-- table here -->
      <div >
        <nz-table class="data-table"
          #basicTable
          [nzData]="listUser ? listUser : []"
          [nzFrontPagination]="false"
          [nzShowPagination]="false"
          [nzScroll]="listUser.length > 7 ? { y: '600px' } : {}"
          nzSize='small'
        >
          <thead>
            <tr class='table-header'>
              <th scope="col" nzWidth="70px">
                {{ 'system.table.stt' | translate }}
              </th>
              <th scope="col">{{ 'system.userRoleConfig.label.table.UserName' | translate }}</th>
              <th scope="col">{{ 'system.userRoleConfig.label.table.EmpCode' | translate }}</th>
              <th scope="col">{{ 'system.userRoleConfig.label.table.FullName' | translate }}</th>
              <th scope="col">
                {{ 'system.userRoleConfig.label.table.Unit' | translate }}
              </th>
            </tr>
          </thead>
          <tbody>
            <tr class='row-table'
              *ngFor="let item of basicTable.data; let i = index; trackBy: trackByUser"
              [class.activeRow]="item.userId == HighlightRowUser"
              (click)="ClickedRowUser($event, item, 'user')"
            >
              <td nzWidth="70px">{{ i + 1 + paginationUserList.size * (paginationUserList.currentPage - 1) }}</td>
              <td>{{ item.username }}</td>
              <td>{{ item.empCode }}</td>
              <td>{{ item.fullName }}</td>
              <td>{{ item.orgName }}</td>
            </tr>
          </tbody>
        </nz-table>
        <div class="pagination-user" nz-row *ngIf="listUser && listUser.length > 0">
            <div class="pagination-user__table-info" nz-col nzMd='24' nzXl='24' nzXXl='10'>
              <img class="pagination-user__table-info--icon" alt="" src="assets/images/icon/idea.svg" />
              <span class="pagination-user__table-info--text"
                >Tìm thấy {{ paginationUserList.totalElements }} kết quả, hiển thị từ
                {{ paginationUserList.size * (paginationUserList.currentPage - 1) + 1 }} đến
                {{
                  paginationUserList.size * (paginationUserList.currentPage - 1) + paginationUserList.numberOfElements
                }}</span
              >
            </div>
            <nz-pagination nz-col nzLg='24' nzXl='24' nzXXl='14'
              [(nzPageIndex)]="paginationUserList.currentPage"
              [nzTotal]="paginationUserList.totalElements"
              [nzPageSize]="paginationUserList.size"
              (nzPageIndexChange)="changePageUser()"
              class="pagination-user__icon"
            >
            </nz-pagination>
        </div>
      </div>
      <!-- end table -->
    </div>
    <div class="container-right" nz-col nzSm='24' nzLg="12">
      <div class="action-top_header">
        <div class="search-container search-right">
          <input
            nz-input
            placeholder="{{ 'common.label.search' | translate }}"
            [(ngModel)]="roleSearch"
            class="input"
            (keyup.enter)="searchDataRole(true)"
          />
          <mb-button class="bt-center" mbButtonType="NO_BORDER" mbButtonSize="VERY_LARGE" (click)="searchDataRole(true)" mbButtonAvailableStyle="SEARCH"
                     mbPrefixIcon="search" nzTooltipTitle="{{'common.label.search' | translate}}" nzTooltipPlacement="bottom" nz-tooltip></mb-button>
        </div>
        <div class="upc-btn-center">
          <mb-button *ngIf="objFunction.import" mbButtonSize="MEDIUM" mbButtonText="{{'common.button.uploadFile' | translate}}"
                     mbButtonTextColor="#141ED2" (click)="doImportData()"></mb-button>
          <mb-import [showContent]='isImportData'
                     (onCloseModal)='doCloseImport($event)'
                     [urlApiDownloadTemp]='urlApiDownloadTemp'
                     [urlApiImport]='urlApiImport'>
          </mb-import>
        </div>
      </div>
      <!-- table here -->
      <div>
        <nz-table class="data-table"
          #basicTableDataRole
          [nzData]="dataRole ? dataRole : []"
          [nzFrontPagination]="false"
          [nzShowPagination]="false"
          [nzPageSize]="limit"
          nzSize='small'
          nzTableLayout='fixed'
          [nzScroll]="dataRole.length > 4 ? { y: '275px' } : {}"
        >
          <thead>
            <tr class='table-header'>
              <th scope="col" nzWidth="10%">
                {{ 'system.table.stt' | translate }}
              </th>
              <th scope="col" nzWidth="35%">{{ 'system.userRoleConfig.label.table.CodeRole' | translate }}</th>
              <th scope="col" nzWidth="55%">
                {{ 'system.userRoleConfig.label.table.NameRole' | translate }}
              </th>
            </tr>
          </thead>
          <tbody>
            <tr class='row-table'
              [class.activeRow]="item.id == HighlightRowPermisson"
              *ngFor="let item of basicTableDataRole.data; let i = index; trackBy: trackByRole"
              (click)="ClickedRowUser($event, item, 'permission')"
            >
              <td>{{ paginationUserRoleAssignList.size * (paginationUserRoleAssignList.currentPage - 1) + 1 + i }}</td>
              <td>{{ item.name }}</td>
              <td>{{ item.description }}</td>
            </tr>
          </tbody>
        </nz-table>
        <div class="pagination" *ngIf="dataRole && dataRole.length > 0 ">
            <div class="pagination__table-info">
              <img class="pagination__table-info--icon" alt="" src="assets/images/icon/idea.svg" />
              <span class="pagination__table-info--text">
                Tìm thấy {{ paginationUserRoleAssignList.totalElements }} kết quả, hiển thị từ

                {{ paginationUserRoleAssignList.size * (paginationUserRoleAssignList.currentPage - 1) + 1 }} đến

                {{
                  paginationUserRoleAssignList.size * (paginationUserRoleAssignList.currentPage - 1) +
                    this.dataRole.length
                }}
              </span>
            </div>
            <nz-pagination
              [(nzPageIndex)]="paginationUserRoleAssignList && paginationUserRoleAssignList.currentPage"
              [nzTotal]="paginationUserRoleAssignList.totalElements"
              [nzPageSize]="paginationUserRoleAssignList.size"
              (nzPageIndexChange)="searchRole('dataRole')"
              class="pagination__icon"
            >
            </nz-pagination>
        </div>
      </div>
      <!-- end table -->
      <nz-divider class="divider"></nz-divider>
      <!--Permission user-->
      <div class="permisson-user">
        <div class="permissonaction_head">
          <div class="permissonaction_head__left">
            <nz-select
              class="select"
              [(ngModel)]="selectedAdmPoliciesId"
              [disabled]="!HighlightRowPermisson"
              (ngModelChange)="selectAdmPolicie($event)"
              nzPlaceHolder="Chọn loại phân quyền"
              nzAllowClear
            >
              <nz-option *ngFor="let data of admPolicies" nzValue="{{ data.polId }}" nzLabel="{{ data.polName }}">
              </nz-option>
            </nz-select>
          </div>
          <div class="permissonaction_head__left">
            <div class="search-container">
              <input
                nz-input
                placeholder="{{ 'common.label.search' | translate }}"
                [(ngModel)]="decentralizationSearch"
                class="input"
                (keyup.enter)="searchDataDecentralization(true)"
              />
              <mb-button class="bt-center" mbButtonType="NO_BORDER" mbButtonSize="VERY_LARGE" (click)="searchDataDecentralization(true)" mbButtonAvailableStyle="SEARCH"
                         mbPrefixIcon="search" nzTooltipTitle="{{'common.label.search' | translate}}" nzTooltipPlacement="bottom" nz-tooltip></mb-button>
            </div>
          </div>
          <div class="permissonaction_head_left__right">
            <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="showModal()" [mbIsDisable]="!selectedAdmPolicies"
                       mbButtonAvailableStyle="PRIMARY" mbButtonText="Chọn Miền Dữ Liệu"></mb-button>
            <ng-template #footerTmpl>
              <mb-button mbButtonType="BORDER" mbButtonAvailableStyle="DEFAULT" mbButtonSize="LARGE" (click)="handleCancel()" mbButtonBgColor="transparent" mbButtonText="{{'common.button.cancelSelect' | translate}}"></mb-button>
              <mb-button *ngIf='objFunction.edit' mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="handleOk()" mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'common.button.select' | translate}}"></mb-button>
            </ng-template>
            <ng-template #icon>
              <mb-button mbButtonType="ONLY_ICON" mbButtonIconType="ZORRO" mbPrefixIcon='close' (click)="handleCancel()" mbButtonAvailableStyle='DEFAULT' ></mb-button>
            </ng-template>
            <nz-modal
              [nzWidth]="'70%'"
              [(nzVisible)]="isVisible"
              nzTitle="{{ titleModal }}"
              [nzFooter]='footerTmpl'
              [nzCloseIcon]= 'icon'
            >
              <ng-container *nzModalContent>
                <app-loading *ngIf="isLoadingModal"></app-loading>
                <div class="search-container search-right w-50 pb-2">
                  <input
                    nz-input
                    placeholder="{{ 'common.label.search' | translate }}"
                    [(ngModel)]="treeSearchItem"
                    class="input"
                    (keyup.enter)="updateFilter()"
                  />
                  <mb-button class="bt-center" mbButtonType="NO_BORDER" mbButtonSize="VERY_LARGE" (click)="updateFilter()" mbButtonAvailableStyle="PRIMARY"
                             mbPrefixIcon="search" nzTooltipTitle="{{'common.label.search' | translate}}" nzTooltipPlacement="bottom" nz-tooltip></mb-button>
                </div>
                <div>
                  <nz-table class="data-table"
                    #expandTable
                    [nzData]="listOfMap"
                    nzTableLayout="fixed"
                    nzSize='small'
                    [nzFrontPagination]="false"
                    [nzShowPagination]="false"
                    [nzScroll]="listOfMap.length > 0 ? { y: '560px' } : {}"
                  >
                    <thead>
                      <tr class='table-header'>
                        <th scope="col" nzWidth="5%">
                          <label *ngIf="listOfMap.length > 0" class="checkbox">
                            <input
                              type="checkbox"
                              [checked]="checked"
                              [(ngModel)]="checked"
                              (ngModelChange)="onAllChecked($event)"
                            />
                            <span class="ck"></span>
                          </label>
                        </th>
                        <th scope="col" nzWidth="30%">
                          {{ 'system.userPermissionConfig.label.table.resourceName' | translate }}
                        </th>
                        <th scope="col" nzWidth="30%">
                          {{ 'system.userPermissionConfig.label.table.resourceCode' | translate }}
                        </th>
                      </tr>
                    </thead>
                    <tbody>
                      <ng-container *ngFor="let data of expandTable.data">
                        <ng-container *ngFor="let item of mapOfExpanded[data.key]; trackBy: trackByNode">
                          <tr *ngIf="(item.parent && item.parent.expand) || !item.parent" class='row-table'>
                            <td>
                              <label class="checkbox">
                                <input
                                  type="checkbox"
                                  [checked]="item.checked"
                                  [(ngModel)]="item.checked"
                                  (ngModelChange)="
                                  onCheckboxDecentralizationFn(mapOfExpanded[data.key], item, $event)
                                  "
                                />
                                <span class="ck"></span>
                              </label>
                            </td>
                            <td
                              [nzIndentSize]="item.level! * 20"
                              [(nzExpand)]="item.expand"
                              (nzExpandChange)="collapses(mapOfExpanded[data.key], item, $event, true)"
                            >
                              <!-- {{ generateAppName(item.dataType) }} -->
                              {{ item.dataName }}
                            </td>
                            <td>{{ item.dataCode }}
                              <input style="float: right;" *ngIf="item.children && item.children.length > 0"
                              type="checkbox"
                              [checked]="item.parentChecked"
                              [(ngModel)]="item.parentChecked"
                              (ngModelChange)="
                                onCheckboxDecentralizationFnParent(mapOfExpanded[data.key], item, $event)
                              "
                            /></td>
                          </tr>
                        </ng-container>
                      </ng-container>
                    </tbody>
                  </nz-table>
                </div>
              </ng-container>
            </nz-modal>
          </div>
        </div>
        <nz-table
          class="data-table"
          nzTableLayout='fixed'
          #PermissonTableDataRole
          [nzData]="dataDecentralization ? dataDecentralization : []"
          [nzFrontPagination]="false"
          [nzShowPagination]="false"
          [nzScroll]="dataDecentralization.length > 7 ? { y: '250px' } : {}"
          nzSize='small'
        >
          <thead>
            <tr class='table-header'>
              <th nzWidth="70px" scope="col">
                {{ 'system.table.stt' | translate }}
              </th>
              <th scope="col">
                {{ 'system.userPermissionConfig.label.table.CodeData' | translate }}
              </th>
              <th scope="col">
                {{ 'system.userPermissionConfig.label.table.NameData' | translate }}
              </th>
            </tr>
          </thead>
          <tbody>
            <tr *ngFor="let item of PermissonTableDataRole.data; let i = index; trackBy: trackByDecentralization" class='row-table'>
              <td nzWidth="70px">{{paginationDecentralizationAssignments.size * (paginationDecentralizationAssignments.currentPage - 1) + 1 + i}}</td>
              <td>{{ item.code }}</td>
              <td>{{ item.name }}</td>
            </tr>
          </tbody>
        </nz-table>
        <div class="pagination-user" *ngIf='dataDecentralization && dataDecentralization.length > 0' nz-row>
            <div class="pagination-user__table-info" nz-col nzMd='24' nzXl='24' nzXXl='12'>
              <img class="pagination-user__table-info--icon" alt="" src="assets/images/icon/idea.svg" />
              <span class="pagination-user__table-info--text">
                Tìm thấy {{ paginationDecentralizationAssignments.totalElements }} kết quả, hiển thị từ

                {{
                  paginationDecentralizationAssignments.size * (paginationDecentralizationAssignments.currentPage - 1) +
                    1
                }}
                đến

                {{
                  paginationDecentralizationAssignments.size * (paginationDecentralizationAssignments.currentPage - 1) +
                    this.dataDecentralization.length
                }}
              </span>
            </div>
            <nz-pagination nz-col nzMd='24' nzXl='24' nzXXl='12'
              [(nzPageIndex)]="paginationDecentralizationAssignments && paginationDecentralizationAssignments.currentPage"
              [nzTotal]="paginationDecentralizationAssignments.totalElements"
              [nzPageSize]="paginationDecentralizationAssignments.size"
              (nzPageIndexChange)="searchRole('decentralization')"
              class="pagination-user__icon"
            >
            </nz-pagination>
        </div>
      </div>
      <!--End Permission user-->
    </div>
  </div>
</nz-card>
